package com.theitbulls.contentproviderex.room;

import android.database.Cursor;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;
import androidx.room.Update;

import java.util.List;

@Dao
public interface EmployeeDAO {
    String TABLE_NAME = "employee";

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    long insert(Employee employee);

    /*@Update(onConflict = OnConflictStrategy.REPLACE)
    void update(Employee employee);*/

    @Query("DELETE FROM " + TABLE_NAME + " WHERE " + Employee.ID + "=:id")
    int delete(long id);

    @Query("DELETE FROM " + TABLE_NAME + " WHERE " + Employee.EMP_ID + "=:empId")
    int delete(String empId);

    @Delete
    int delete(Employee employee);

    @Query("SELECT * FROM " + TABLE_NAME + " WHERE " + Employee.ID + "=:id")
    Employee getEmployee(long id);

    @Query("SELECT * FROM " + TABLE_NAME + " WHERE " + Employee.EMP_ID + "=:empId")
    Employee getEmployee(String empId);

    @Query("SELECT * FROM " + TABLE_NAME)
    List<Employee> list();

    @Query("SELECT * FROM " + TABLE_NAME)
    Cursor selectAll();

    @Query("SELECT * FROM " + TABLE_NAME + " WHERE " + Employee.ID + "=:id")
    Cursor selectById(long id);
}
